"""
Base deccandelight Scraper class
Copyright (C) 2016 Gujal

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
"""

import xbmc
import xbmcaddon
import json
import re
import requests
import urllib
from BeautifulSoup import BeautifulSoup, SoupStrainer
from resources.lib import jsunpack
import resolveurl

_addon = xbmcaddon.Addon()
_addonname = _addon.getAddonInfo('name')
_version = _addon.getAddonInfo('version')
_addonID = _addon.getAddonInfo('id')
_icon = _addon.getAddonInfo('icon')
_fanart = _addon.getAddonInfo('fanart')
_path = _addon.getAddonInfo('path')
_ipath = _path + '/resources/images/'
_settings = _addon.getSetting
_timeout = _settings('timeout')

mozhdr = {'User-Agent': 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3'}
ioshdr = {'User-Agent': 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0_1 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A402 Safari/604.1'}
droidhdr = {'User-Agent': 'Dalvik/2.1.0 (Linux; U; Android 5.1.1; SM-G610F Build/LMY48Z)'}
jiohdr = {'User-Agent': 'ExoPlayerDemo/5.2.0 (Linux;Android 6.0.1) ExoPlayerLib/2.3.0'}


class Scraper(object):

    def __init__(self):
        self.ipath = _ipath
        self.hdr = mozhdr
        self.dhdr = droidhdr
        self.jhdr = jiohdr
        self.ihdr = ioshdr
        self.settings = _settings
        self.adult = _settings('adult')
        self.nicon = self.ipath + 'next.png'

    def get_nicon(self):
        return self.nicon

    def log(self, text, caption=None):
        if not caption:
            caption = '@@@@Deccandelight log'
        xbmc.log('{} = {}'.format(caption, text), xbmc.LOGNOTICE)

    def get_SearchQuery(self, sitename):
        keyboard = xbmc.Keyboard()
        keyboard.setHeading('Search ' + sitename)
        keyboard.doModal()
        if keyboard.isConfirmed():
            search_text = keyboard.getText()

        return search_text

    def get_vidhost(self, url):
        """
        Trim the url to get the video hoster
        :return vidhost
        """
        parts = url.split('/')[2].split('.')
        vidhost = '{}.{}'.format(parts[len(parts) - 2], parts[len(parts) - 1])
        return vidhost

    def resolve_media(self, url, videos, vidtxt=''):
        non_str_list = ['olangal.', 'magnet:', 'desihome.', 'thiruttuvcd', '.filmlinks4u',
                        'cineview', 'bollyheaven', 'videolinkz', 'moviefk.co', 'goo.gl',
                        'imdb.', 'mgid.', 'atemda.', 'movierulz.ht', 'facebook.', 'twitter.',
                        'm2pub', 'abcmalayalam', 'india4movie.co', 'embedupload.', '#',
                        'tamilraja.', 'multiup.', 'filesupload.', 'fileorbs.', 'tamil.ws',
                        'insurance-donate.', '.blogspot.', 'yodesi.net', 'desi-tashan.',
                        'yomasti.co/ads', 'ads.yodesi', '/ads/', 'mylifeads.', 'yaartv.',
                        'steepto.', '/movierulztv', '/email-protection', 'oneload.xyz']

        dhoolembed = ['thiraifour.com', 'tamilbliss.com', 'thirailight.com']

        embed_list = ['cineview', 'bollyheaven', 'videolinkz', 'vidzcode', 'escr.',
                      'embedzone', 'embedsr', 'fullmovie-hd', 'links4.pw', 'esr.',
                      'embedscr', 'embedrip', 'movembed', 'power4link.us', 'adly.biz',
                      'watchmoviesonline4u', 'nobuffer.info', 'yomasti.co', 'hd-rulez.',
                      'techking.me', 'onlinemoviesworld.xyz', 'cinebix.com', 'vids.xyz',
                      'desihome.', 'loan-', 'filmshowonline.', 'hinditwostop.', 'media.php',
                      'hindistoponline', 'telly-news.', 'tellytimes.', 'techking.',
                      'business-', 'businessvoip.', 'toptencar.', 'serialinsurance.',
                      'youpdates', 'loanadvisor.', 'tamilray.', 'embedrip.', 'xpressvids.',
                      'beststopapne.', 'bestinforoom.', '?trembed=', 'tamilserene.',
                      'etcscrs.', 'etcsr1.', 'etcrips.']

        headers = {}
        if '|' in url:
            url, hdrs = url.split('|')
            hitems = hdrs.split('&')
            for hitem in hitems:
                hdr, value = hitem.split('=')
                headers.update({hdr: value})
        if 'filmshowonline.net/media/' in url:
            try:
                headers.update(self.hdr)
                r = requests.get(url, headers=headers)
                clink = r.text
                cookies = r.cookies
                eurl = re.findall(r"var\s*height.+?url:\s*'([^']+)", clink, re.DOTALL)[0]
                if not eurl.startswith('http'):
                    eurl = 'https:' + eurl
                enonce = re.findall(r"var\s*height.+?nonce.+?'([^']+)", clink, re.DOTALL)[0]
                evid = re.findall(r"var\s*height.+?link_id:\s*([^\s]+)", clink, re.DOTALL)[0]
                values = {'echo': 'true',
                          'nonce': enonce,
                          'width': '848',
                          'height': '480',
                          'link_id': evid}
                headers = self.hdr
                headers.update({'Referer': url, 'X-Requested-With': 'XMLHttpRequest'})
                emdiv = requests.post(eurl, data=values, headers=headers, cookies=cookies).json()['embed']
                strurl = re.findall('(http[^"]+)', emdiv)[0]
                if resolveurl.HostedMediaFile(strurl):
                    vidhost = self.get_vidhost(strurl)
                    if vidtxt != '':
                        vidhost += ' | %s' % vidtxt
                    videos.append((vidhost, strurl))
            except:
                pass

        elif any([x in url for x in dhoolembed]):
            strurl = url.replace('/p/', '/v/') + '.m3u8'
            vidhost = self.get_vidhost(strurl)
            if vidtxt != '':
                vidhost += ' | %s' % vidtxt
            videos.append((vidhost, strurl))

        elif 'justmoviesonline.com' in url:
            headers.update(self.hdr)
            html = requests.get(url, headers=headers).text
            src = re.search(r"atob\('(.*?)'", html)
            if src:
                src = src.group(1)
                try:
                    strurl = re.findall('file":"(.*?)"', src.decode('base64'))[0]
                    vidhost = 'GVideo'
                    strurl = urllib.quote_plus(strurl)
                    videos.append((vidhost, strurl))
                except:
                    pass
                try:
                    strurl = re.findall('''source src=["'](.*?)['"]''', src.decode('base64'))[0]
                    vidhost = self.get_vidhost(strurl)
                    videos.append((vidhost, strurl))
                except:
                    pass
            elif '?id=' in url:
                src = eval(re.findall('Loading.+?var.+?=([^;]+)', html, re.DOTALL)[0])
                for item in src:
                    if 'http' in item and 'justmovies' not in item:
                        strurl = item
                strurl += url.split('?id=')[1]
                strurl += '.mp4|User-Agent={}'.format(mozhdr['User-Agent'])
                vidhost = 'GVideo'
                strurl = urllib.quote_plus(strurl)
                videos.append((vidhost, strurl))

        elif 'videohost.site' in url or 'videohost1.com' in url:
            try:
                headers.update(self.hdr)
                html = requests.get(url, headers=headers).text
                pdata = eval(re.findall(r'Run\((.*?)\)', html)[0]).decode('base64')
                linkcode = jsunpack.unpack(pdata).replace('\\', '')
                sources = json.loads(re.findall(r'sources:(.*?\}\])', linkcode)[0])
                for source in sources:
                    strurl = source['file'] + '|Referer={}'.format(url)
                    vidhost = self.get_vidhost(url) + ' | GVideo | {}'.format(source['label'])
                    strurl = urllib.quote_plus(strurl)
                    videos.append((vidhost, strurl))
            except:
                pass

        elif 'akamaihd.' in url:
            vidhost = self.get_vidhost(url)
            videos.append((vidhost, url))

        elif 'videohost2.com' in url:
            headers.update(self.hdr)
            html = requests.get(url, headers=headers).text

            try:
                pdata = eval(re.findall(r'Loading video.+?(\[.+?\]);', html, re.DOTALL)[0])
                if 'id=' in url:
                    strurl = pdata[7] + url.split('=')[1] + pdata[9]
                else:
                    strurl = pdata[7]
                vidhost = self.get_vidhost(url) + ' | GVideo'
                strurl = urllib.quote_plus(strurl + '|Referer={}'.format(url))
                videos.append((vidhost, strurl))
            except:
                pass

            try:
                pdata = re.findall(r"atob\('([^']+)", html)[0].decode('base64')
                strurl = re.findall(r"source\ssrc='([^']+)", pdata)[0] + '|Referer={}'.format(url)
                vidhost = self.get_vidhost(url)
                strurl = urllib.quote_plus(strurl)
                videos.append((vidhost, strurl))
            except:
                pass

        elif 'hindistoponline' in url or 'hindigostop' in url:
            headers.update(self.hdr)
            url = url.replace('www.hindistoponline.com', 'hindigostop.com')
            html = requests.get(url, headers=headers).text

            try:
                strurl = re.findall(r'source:\s*"([^"]+)', html)[0]
                vidhost = self.get_vidhost(strurl)
                strurl = urllib.quote_plus(strurl + '|User-Agent={}&Referer={}'.format(mozhdr['User-Agent'], url))
                videos.append((vidhost, strurl))
            except:
                pass

            try:
                strurl = re.findall('''(?i)<iframe.+?src=["']([^'"]+)''', html)[0]
                if resolveurl.HostedMediaFile(strurl):
                    vidhost = self.get_vidhost(strurl)
                    videos.append((vidhost, strurl))
                else:
                    self.log('ResolveUrl cannot resolve : {}'.format(url))
            except:
                pass

        elif 'tamildbox' in url:
            if 'embed' in url:
                thdr = mozhdr
                thdr['Referer'] = url
                r = requests.get(url, headers=thdr).text
                match = re.search(r"domainStream\s*=\s*'([^']+)", r)
                if match:
                    surl = match.group(1)
                    if 'vidyard' in surl:
                        surl += '|Referer=https://play.vidyard.com/'
                    else:
                        surl = surl.replace('/hls/', '/hlss/')
                        surl += '|Referer=https://embed1.tamildbox.tips/'
                    surl += '&User-Agent={}'.format(mozhdr['User-Agent'])
                else:
                    surl = url.replace('hls_vast', 'hls').replace('.tamildbox.tips', '.tamilgun.tv')
                    surl += '/playlist.m3u8'
                vidhost = self.get_vidhost(surl)
                videos.append((vidhost, surl))
            else:
                link = requests.get(url, headers=mozhdr).text

                try:
                    etext = re.search(r'file:\s*"([^"]+).+?type:\s*"([^"]+)', link, re.DOTALL)
                    if etext:
                        glink = etext.group(1)
                        vidhost = self.get_vidhost(glink) + ' | {}'.format(etext.group(2))
                        if 'http' not in glink:
                            glink = 'http:' + glink
                        videos.append((vidhost, glink))
                    etext = re.search(r'file":\s*"([^"]+).+?label":\s*"([^"]+)', link, re.DOTALL)
                    if etext:
                        glink = etext.group(1)
                        vidhost = self.get_vidhost(glink) + ' | {}'.format(etext.group(2))
                        if 'http' not in glink:
                            glink = 'http:' + glink
                        videos.append((vidhost, glink))
                except:
                    pass

                try:
                    mlink = SoupStrainer('div', {'id': 'player-embed'})
                    dclass = BeautifulSoup(link, parseOnlyThese=mlink)
                    if 'unescape' in str(dclass):
                        etext = re.findall("unescape.'[^']*", str(dclass))[0]
                        etext = urllib.unquote(etext)
                        dclass = BeautifulSoup(etext)
                    glink = dclass.iframe.get('src')
                    if resolveurl.HostedMediaFile(glink):
                        vidhost = self.get_vidhost(glink)
                        videos.append((vidhost, glink))
                except:
                    pass

                try:
                    mlink = SoupStrainer('div', {'class': re.compile('^item-content')})
                    dclass = BeautifulSoup(link, parseOnlyThese=mlink)
                    glink = dclass.p.iframe.get('src')
                    if resolveurl.HostedMediaFile(glink):
                        vidhost = self.get_vidhost(glink)
                        videos.append((vidhost, glink))
                except:
                    pass

                try:
                    if 'p,a,c,k,e,d' in link:
                        linkcode = jsunpack.unpack(link).replace('\\', '')
                        glink = re.findall(r"file\s*:\s*'(.*?)'", linkcode)[0]
                    if 'youtu.be' in glink:
                        glink = 'https://docs.google.com/vt?id=' + glink[16:]
                    if resolveurl.HostedMediaFile(glink):
                        vidhost = self.get_vidhost(glink)
                        videos.append((vidhost, glink))
                except:
                    pass

                try:
                    codes = re.findall(r'"return loadEP.([^,]*),(\d*)', link)
                    for ep_id, server_id in codes:
                        burl = 'http://{}/actions.php?case=loadEP&ep_id={}&server_id={}'.format(url.split('/')[2], ep_id, server_id)
                        bhtml = requests.get(burl, headers=mozhdr).text
                        blink = re.findall('<iframe.+?src="([^"]+)', bhtml, re.IGNORECASE)[0]
                        if blink.startswith('//'):
                            blink = 'https:' + blink
                        if 'googleapis' in blink:
                            blink = 'https://drive.google.com/open?id=' + re.findall('docid=([^&]*)', blink)[0]
                            vidhost = 'GVideo'
                            videos.append((vidhost, blink))
                        elif 'tamildbox.' in blink:
                            if 'embed' in blink:
                                thdr = mozhdr
                                thdr['Referer'] = blink
                                r = requests.get(blink, headers=thdr).text
                                match = re.search(r"domainStream\s*=\s*'([^']+)", r)
                                if match:
                                    surl = match.group(1)
                                    if 'vidyard' in surl:
                                        surl += '|Referer=https://play.vidyard.com/'
                                    else:
                                        if '.php' not in surl:
                                            surl += '/playlist.m3u8'
                                        surl += '|Referer=https://embed1.tamildbox.tips/'
                                    surl += '&User-Agent={}'.format(mozhdr['User-Agent'])
                                else:
                                    surl = blink.replace('hls_vast', 'hls')
                                    surl = surl.replace('.tamildbox.tips', '.tamilgun.tv')
                                    surl += '/playlist.m3u8'
                                vidhost = self.get_vidhost(surl)
                                if (vidhost, surl) not in videos:
                                    videos.append((vidhost, surl))
                            else:
                                link = requests.get(blink, headers=mozhdr).text
                                etext = re.search(r'file:\s*"([^"]+).+?type:\s*"([^"]+)', link, re.DOTALL)
                                if etext:
                                    glink = etext.group(1)
                                    vidhost = self.get_vidhost(glink) + ' | {}'.format(etext.group(2))
                                    if glink.startswith('//'):
                                        glink = 'https:' + glink
                                    if (vidhost, glink) not in videos:
                                        videos.append((vidhost, glink))
                                etext = re.search(r'file":\s*"([^"]+).+?label":\s*"([^"]+)', link, re.DOTALL)
                                if etext:
                                    glink = etext.group(1)
                                    vidhost = self.get_vidhost(glink) + ' | {}'.format(etext.group(2))
                                    if glink.startswith('//'):
                                        glink = 'https:' + glink
                                    if (vidhost, glink) not in videos:
                                        videos.append((vidhost, glink))
                        elif 'cdn.' in blink:
                            thdr = mozhdr
                            thdr['Referer'] = url
                            link = requests.get(blink, headers=thdr).text
                        else:
                            if resolveurl.HostedMediaFile(blink):
                                vidhost = self.get_vidhost(blink)
                                videos.append((vidhost, blink))
                            else:
                                self.log('Resolveurl cannot resolve : {}'.format(blink))
                except:
                    pass

        elif 'tamilthee.' in url:
            vidhost = self.get_vidhost(url)
            vidurl = url.replace('/p/', '/v/') + '.m3u8'
            videos.append((vidhost, vidurl))

        elif '.box.' in url and '.mp4' in url:
            vidhost = self.get_vidhost(url)
            videos.append((vidhost, url))

        elif any([x in url for x in embed_list]):
            url = url.replace('hd-rulez.info/', 'business-mortgage.biz/')
            url = url.replace('hinditwostop.com/', 'bestinforoom.com/')
            url = url.replace('beststopapne.com/', 'bestinforoom.com/')
            vidcount = 0
            headers.update(self.hdr)
            clink = requests.get(url, headers=headers).text
            csoup = BeautifulSoup(clink)

            try:
                url2 = csoup.find('meta', {'http-equiv': 'refresh'}).get('content').split('URL=')[-1]
                if any([x in url2 for x in embed_list]):
                    clink = requests.get(url2, headers=headers).text
                    csoup = BeautifulSoup(clink)
                else:
                    self.log('Cannot Process : {}'.format(url2))
            except:
                pass

            try:
                links = re.findall('''<iframe.+?src=["']?([^'" ]+)''', clink, re.IGNORECASE)
                for strurl in links:
                    # self.log('-------> Scraped link : %s' % strurl)
                    if any([x in strurl for x in ['apnevideotwo', 'player.business']]):
                        vidhost = 'CDN Direct'
                        if vidtxt:
                            vidhost += ' | %s' % vidtxt
                        videos.append((vidhost, strurl))
                        vidcount += 1
                    elif not any([x in strurl for x in non_str_list]) and not any([x in strurl for x in embed_list]):
                        # self.log('-------> sending to resolveurl for checking : %s' % strurl)
                        if resolveurl.HostedMediaFile(strurl):
                            vidhost = self.get_vidhost(strurl)
                            if vidtxt != '':
                                vidhost += ' | %s' % vidtxt
                            videos.append((vidhost, strurl))
                            vidcount += 1
                        else:
                            self.log('Resolveurl cannot resolve : {}'.format(strurl))
            except:
                pass

            try:
                sources = re.findall(r'sources:\s*([^\]]+)', clink, re.DOTALL)[0]
                links = re.findall(r'''src:\s*['"]([^"']+)''', sources)
                for strurl in links:
                    # self.log('-------> Scraped link : %s' % strurl)
                    vidhost = self.get_vidhost(strurl)
                    if vidtxt != '':
                        vidhost += ' | %s' % vidtxt
                    videos.append((vidhost, strurl))
                    vidcount += 1
            except:
                pass

            try:
                r = re.search(r'jwplayer\("container"\).setup\({\s*\n\s*file:\s*"([^"]+)', clink)
                if r:
                    strurl = r.group(1)
                    vidhost = self.get_vidhost(strurl)
                    if vidtxt != '':
                        vidhost += ' | %s' % vidtxt
                    videos.append((vidhost, strurl))
                    vidcount += 1
            except:
                pass

            try:
                plink = csoup.find('a', {'class': 'main-button dlbutton'})
                strurl = plink.get('href')
                if not any([x in strurl for x in non_str_list]):
                    if resolveurl.HostedMediaFile(strurl):
                        vidhost = self.get_vidhost(strurl)
                        if vidtxt != '':
                            vidhost += ' | %s' % vidtxt
                        videos.append((vidhost, strurl))
                        vidcount += 1
                    else:
                        self.log('Resolveurl cannot resolve : {}'.format(strurl))
            except:
                pass

            try:
                plink = csoup.find('div', {'class': 'aio-pulse'})
                strurl = plink.find('a')['href']
                if not any([x in strurl for x in non_str_list]) and not any([x in strurl for x in embed_list]):
                    if resolveurl.HostedMediaFile(strurl):
                        vidhost = self.get_vidhost(strurl)
                        if vidtxt != '':
                            vidhost += ' | {}'.format(vidtxt)
                        videos.append((vidhost, strurl))
                        vidcount += 1
                    else:
                        self.log('Resolveurl cannot resolve : {}'.format(strurl))
            except:
                pass

            try:
                plink = csoup.find('div', {'class': re.compile('entry-content')})
                strurl = plink.find('a')['href']
                if not any([x in strurl for x in non_str_list]) and not any([x in strurl for x in embed_list]):
                    if resolveurl.HostedMediaFile(strurl):
                        vidhost = self.get_vidhost(strurl)
                        if vidtxt != '':
                            vidhost += ' | %s' % vidtxt
                        videos.append((vidhost, strurl))
                        vidcount += 1
                    else:
                        self.log('Resolveurl cannot resolve : {}'.format(strurl))
            except:
                pass

            try:
                for linksSection in csoup.findAll('embed'):
                    strurl = linksSection.get('src')
                    if not any([x in strurl for x in non_str_list]) and not any([x in strurl for x in embed_list]):
                        if resolveurl.HostedMediaFile(strurl):
                            vidhost = self.get_vidhost(strurl)
                            if vidtxt != '':
                                vidhost += ' | %s' % vidtxt
                            videos.append((vidhost, strurl))
                            vidcount += 1
                    else:
                        self.log('Resolveurl cannot resolve : {}'.format(strurl))
            except:
                pass

            try:
                plink = csoup.find('div', {'id': 'Proceed'})
                strurl = plink.find('a')['href']
                if not any([x in strurl for x in non_str_list]) and not any([x in strurl for x in embed_list]):
                    if resolveurl.HostedMediaFile(strurl):
                        vidhost = self.get_vidhost(strurl)
                        if vidtxt != '':
                            vidhost += ' | %s' % vidtxt
                        videos.append((vidhost, strurl))
                        vidcount += 1
                    else:
                        self.log('Resolveurl cannot resolve : {}'.format(strurl))
            except:
                pass

            try:
                vid = re.findall(r'tune\.pk[^?]+\?vid=([^&]+)', clink)[0]
                strurl = 'https://tune.pk/video/{vid}/'.format(vid=vid)
                if resolveurl.HostedMediaFile(strurl):
                    vidhost = self.get_vidhost(strurl)
                    if vidtxt != '':
                        vidhost += ' | %s' % vidtxt
                    videos.append((vidhost, strurl))
                    vidcount += 1
                else:
                    self.log('Resolveurl cannot resolve : {}'.format(strurl))
            except:
                pass

            try:
                vidurl = re.search(r'file\s*:\s*"([^"]+)', clink)
                if vidurl:
                    vidurl = vidurl.group(1)
                    vidhost = self.get_vidhost(vidurl)
                    videos.append((vidhost, vidurl))
                    vidcount += 1
            except:
                pass

            if vidcount == 0:
                self.log('Could not procees link : {}'.format(url))

        elif not any([x in url for x in non_str_list]):
            if resolveurl.HostedMediaFile(url):
                vidhost = self.get_vidhost(url)
                if vidtxt != '':
                    vidhost += ' | %s' % vidtxt
                videos.append((vidhost, url))
            else:
                self.log('ResolveUrl cannot resolve : {}'.format(url))

        return

    def clean_title(self, title):
        cleanup = ['Watch Online Movie', 'Watch Onilne', 'Tamil Movie ', 'Tamil Dubbed', 'WAtch ', 'Online Free',
                   'Full Length', 'Latest Telugu', 'RIp', 'DvDRip', 'DvDScr', 'Full Movie Online Free', 'Uncensored',
                   'Full Movie Online', 'Watch Online ', 'Free HD', 'Online Full Movie', 'Downlaod', 'Bluray',
                   'Full Free', 'Malayalam Movie', ' Malayalam ', 'Full Movies', 'Full Movie', 'Free Online',
                   'Movie Online', 'Watch ', 'movie online', 'Wach ', 'Movie Songs Online', 'Full Hindi', 'Korean',
                   'tamil movie songs online', 'tamil movie songs', 'movie songs online', 'Tamil Movie', ' Hindi',
                   'Hilarious Comedy Scenes', 'Super Comedy Scenes', 'Ultimate Comedy Scenes', 'Watch...', 'BDRip',
                   'Super comedy Scenes', 'Comedy Scenes', 'hilarious comedy Scenes', '...', 'Telugu Movie',
                   'Sun TV Show', 'Vijay TV Show', 'Vijay Tv Show', 'Vijay TV Comedy Show', 'Hindi Movie', 'Film',
                   'Vijay Tv Comedy Show', 'Vijay TV', 'Vijay Tv', 'Sun Tv Show', 'Download', 'Starring', u'\u2013',
                   'Tamil Full Movie', 'Tamil Horror Movie', 'Tamil Dubbed Movie', '|', '-', ' Full ', u'\u2019',
                   '/', 'Pre HDRip', '(DVDScr Audio)', 'PDVDRip', 'DVDSCR', '(HQ Audio)', 'HQ', ' Telugu', 'BRRip',
                   'DVDScr', 'DVDscr', 'PreDVDRip', 'DVDRip', 'DVDRIP', 'WEBRip', 'WebRip', 'Movie ', ' Punjabi',
                   'TCRip', 'HDRip', 'HDTVRip', 'HD-TC', 'HDTV', 'TVRip', '720p', 'DVD', 'HD', ' Dubbed', '( )',
                   '720p', '(UNCUT)', 'UNCUT', '(Clear Audio)', 'DTHRip', '(Line Audio)', ' Kannada', ' Hollywood',
                   'TS', 'CAM', 'Online Full', '[+18]', 'Streaming Free', 'Permalink to ', 'And Download', '()',
                   'Full English', ' English', 'Online', ' Tamil', ' Bengali', ' Bhojpuri', 'Print Free', 'Free']

        for word in cleanup:
            if word in title:
                title = title.replace(word, '')

        title = title.strip()
        title = title.encode('utf8')
        return title
